数位DP练习

水题

发布时间: 2017年6月22日 19:15   最后更新: 2017年6月23日 20:10   时间限制: 1000ms   内存限制: 128M

描述

给一个数n,求0~n内有多少个数满足其二进制形式不存在相邻的1

比如 0,1,2是可以的,3不可以。

输入

多组输入,每组输入一个数。

输出

输出答案,

样例输入1 复制

0

样例输出1

1

提示

数位DP

代码1:

 1 #include<stdio.h>
 2 #include<iostream>
 3 #include<algorithm>
 4 #include<string.h>
 5 #include<math.h>
 6 #include<stdlib.h>
 7 #include<ctype.h>
 8 #include<stack>
 9 #include<queue>
10 #include<map>
11 #include<set>
12 #include<vector>
13 #define ll long long
14 #define  db double
15 using namespace std;
16 const int N=1e6+5;
17 const int mod=1e9+7;
18 int n;
19 ll dp[64][2][2];
20 int a[100];
21 ll dfs(int p,int pre,int st,int lim){//统计存在相邻1的数字
22     if(p==-1) return st==1;
23     if(!lim&&dp[p][pre][st]!=-1) return dp[p][pre][st];
24     ll ans=0;
25     int up=lim?a[p]:1;
26     for(int i=0;i<=up;i++){
27         int nst=st;
28         if(i&&pre) nst=1;
29         ans+=dfs(p-1,i,nst,lim&&i==a[p]);
30     }
31     if(!lim) dp[p][pre][st]=ans;
32     return ans;
33 }
34 void f(int n){
35     int k=n;
36     memset(dp,-1, sizeof(dp));
37     memset(a,0, sizeof(a));
38     int cnt=0;
39     while(n){
40         a[cnt++]=n%2;
41         n/=2;
42     }
43     printf("%lld\n",k+1-dfs(cnt-1,0,0,1));
44 }
45 int main(){
46     while(scanf("%d",&n)==1){
47         f(n);
48     }
49 }

标程:

 1 #include<bits/stdc++.h>
 2 using namespace std;
 3 const int N = 1e5+5;
 4 typedef long long ll;
 5
 6 ll dp[N][2];
 7 int a[N];
 8
 9 ll dfs(int p,int pre,bool lim)//统计不存在相邻1的数字个数
10 {
11     if(pos == -1)     return 1;
12     if(!lim && dp[p][pre] != -1)
13         return dp[p][pre];
14     int up = lim ? a[p] : 1;
15     ll ans = 0;
16     for(int i =0;i<=up;i++)
17     {
18         if(pre&& i)  continue;
19         ans += dfs(p-1,i,lim&&i==a[p]);
20     }
21     if(!lim)    dp[p][pre] = ans;
22     return ans;
23 }
24 ll solve(ll n)
25 {
26     memset(dp,-1,sizeof(dp));
27     memset(a,0,sizeof(a));
28     int cnt = 0;
29     while(n)
30     {
31         a[cnt++] = n % 2;
32         n /= 2;
33     }
34     return dfs(cnt-1,0,1);
35 }
36 int main()
37 {
38     ll n;
39     while(cin >> n)
40     {
41         cout << solve(n) << endl;
42     }
43 }
时间: 2024-10-25 10:10:17

数位DP练习的相关文章

51Nod 1009 数字1的个数 | 数位DP

题意: 小于等于n的所有数中1的出现次数 分析: 数位DP 预处理dp[i][j]存 从1~以j开头的i位数中有几个1,那么转移方程为: if(j == 1) dp[i][j] = dp[i-1][9]*2+pow(10,i-1);else dp[i][j] = dp[i-1][9]+dp[i][j-1]; 然后注意下对于每个询问统计的时候如果当前位为1需要额外加上他后面所有位数的个数,就是n%pow(10,i-1); 这样总复杂度log(n)*10 #include <bits/stdc++.

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

51nod1043(数位dp)

题目链接:https://www.51nod.com/onlineJudge/questionCode.html#!problemId=1043 题意:中文题诶- 思路:数位dp 我们用dp[i][j]来存储长度为2*i且一半和为j的所有情况(包括前导0的情况),为了方便我们现在只讨论其一半的和的情况,因为如果包括前导0的话其两边的情况是一样的: 我们假设再长度为i-1的数字最前面加1位数字k,0<=k<=9(这位数字加在哪里并不影响答案,因为我们在计算i-1长度的时候已经计算了所有组合情况,

数位dp

1.[hdu3709]Balanced Number 1 #include<iostream> 2 #include<cstdio> 3 #include<cstring> 4 #include<string> 5 #include<cstdlib> 6 #include<algorithm> 7 #include<ctime> 8 #include<cmath> 9 #include<queue>

【HDU 3652】 B-number (数位DP)

B-number Problem Description A wqb-number, or B-number for short, is a non-negative integer whose decimal form contains the sub- string "13" and can be divided by 13. For example, 130 and 2613 are wqb-numbers, but 143 and 2639 are not. Your task

hdu 5898 odd-even number 数位DP

odd-even number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 716    Accepted Submission(s): 385 Problem Description For a number,if the length of continuous odd digits is even and the length

LightOJ1068 Investigation(数位DP)

这题要求区间有多少个模K且各位数之和模K都等于0的数字. 注意到[1,231]这些数最大的各位数之和不会超过90左右,而如果K大于90那么模K的结果肯定不是0,因此K大于90就没有解. 考虑到数据规模,数据组数,这题状态这么表示: dp[i][j][k]:位数为i模K结果为j且各位数之和模K结果为k的数字个数 然后就是转移方程,最后就是统计.. 统计部分好棘手...半乱搞下AC的..还是对数位DP的这一部分太不熟悉了. 1 #include<cstdio> 2 #include<cstr

HDU 4734 F(x)(数位DP)

Description For a decimal number x with n digits (A nA n-1A n-2 ... A 2A 1), we define its weight as F(x) = A n * 2 n-1 + A n-1 * 2 n-2 + ... + A 2 * 2 + A1 * 1. Now you are given two numbers A and B, please calculate how many numbers are there betwe

hdu 4734 数位dp

http://acm.hdu.edu.cn/showproblem.php?pid=4734 Problem Description For a decimal number x with n digits (AnAn-1An-2 ... A2A1), we define its weight as F(x) = An * 2n-1 + An-1 * 2n-2 + ... + A2 * 2 + A1 * 1. Now you are given two numbers A and B, plea

【POJ3208】传说中POJ最难的数位DP?(正解AC自动机,二解数位DP,吾异与之)

题意: 多组数据,每组求第n个包含'666'的数(不能断开),如1:666,2:1666,14:6667. 题解: AC自动机解法没去想,数位DP没学,这里有一种类似于数位DP,却又与数位DP不同,我称为数位树. 数位树: 将数n如线段树一样地拆分成多个小段,进行递归处理得出答案. 本题详(lue)解: 直接看每一位应该是什么数,然后n减去相应的数,使得在下一层转换为子问题"在开头有b个连续的6时,求第a个带'666'的数".就是如此简单,如此简单!!!! 代码来啦! #include